module dac_test(clock,key,wr_act,wr_data,seg,dig);
input clock;							//ϵͳʱ(48MHz)
input[4:0] key;							//(KEY1~KEY5)
output wr_act;							//ʹ
output[10:0]wr_data;					//Ҫ͵
output[7:0]seg;							//ܶ
output[7:0]dig;							//λ
//I/OĴ
reg[10:0]wr_data;	
reg wr_act;
reg[7:0]seg;		
reg[7:0]dig;		
//ڲĴ
reg[16:0]count;							//ʱӷƵ
reg[4:0]dout1,dout2,dout3;				//Ĵ
reg[4:0]buff;							//ؼĴ
reg[1:0] cnt;					  		//ɨ	
reg[3:0]disp_dat;				    	//ɨԴ		
reg div_clk;							//Ƶʱ
wire[4:0] key_edge;

//ʱӷƵ
always @(posedge clock)
begin
	if (count < 17'd120000)
	begin
 	    count <= count + 1'b1;
 	    div_clk <= 1'b0;
 	end
 	else
 	begin
 	    count <= 17'd0;
 	    div_clk <= 1'b1;
 	end
end

//
always @(posedge clock)
begin
	if(div_clk)
	begin
		dout1 <= key;
		dout2 <= dout1;
		dout3 <= dout2;
	end	
end

//ؼⲿ
always @(posedge clock)
begin
	buff <= dout1 | dout2 | dout3;
end

assign key_edge = ~(dout1 | dout2 | dout3) & buff;


always @(posedge clock)							//1
begin
	if(key_edge[0])								//½ؼ
	wr_data[10:9] <= wr_data[10:9] + 1'b1;
end

always @(posedge clock)							//2
begin
	if(key_edge[1])								//½ؼ
	wr_data[7:4] <= wr_data[7:4] + 1'b1;
end

always @(posedge clock)							//3
begin
	if(key_edge[2])								//½ؼ
	wr_data[3:0] <= wr_data[3:0] + 1'b1;
end

always @(posedge clock)							//4
begin
	if(key_edge[3])								//½ؼ
	wr_data[8] <= ~wr_data[8];
end

always @(posedge clock)							//5
begin
	if(key_edge[4])								//½ؼ
		wr_act <= 1'b1;
	else 
		wr_act <= 1'b0; 
end


//ɨʾ
always @(posedge clock)   				//ش
begin
	if(div_clk)
		cnt <= cnt + 1'b1;
end

always @(posedge clock)   						
begin
	if(div_clk)
	begin
		case(cnt)									//ѡɨʾ
			2'd0:disp_dat = wr_data[10:9] + 4'd1;	//һ
			2'd1:disp_dat = wr_data[7:4];			//
			2'd2:disp_dat = wr_data[3:0];			//ĸ
			2'd3:disp_dat = {3'b0,wr_data[8]};		//ڰ˸
		endcase
		case(cnt)									//ѡʾλ
			2'd0:dig = 8'b01111111;					//ѡһʾ
			2'd1:dig = 8'b11011111;					//ѡʾ
			2'd2:dig = 8'b11101111;					//ѡĸʾ
			2'd3:dig = 8'b11111110;					//ѡڰ˸ʾ
		endcase	
	end
end

always @(disp_dat)
begin
	case(disp_dat)						//߶
		4'h0:seg = 8'hc0;				//ʾ0
		4'h1:seg = 8'hf9;				//ʾ1
		4'h2:seg = 8'ha4;				//ʾ2
		4'h3:seg = 8'hb0;				//ʾ3
		4'h4:seg = 8'h99;				//ʾ4
		4'h5:seg = 8'h92;				//ʾ5
		4'h6:seg = 8'h82;				//ʾ6
		4'h7:seg = 8'hf8;				//ʾ7
		4'h8:seg = 8'h80;				//ʾ8
		4'h9:seg = 8'h90;				//ʾ9
		4'ha:seg = 8'h88;				//ʾa
		4'hb:seg = 8'h83;				//ʾb
		4'hc:seg = 8'hc6;				//ʾc
		4'hd:seg = 8'ha1;				//ʾd
		4'he:seg = 8'h86;				//ʾe
		4'hf:seg = 8'h8e;				//ʾf
	endcase
end

endmodule